<template>
  <div class="app-container">

    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="中文名称" prop="titleZh">
        <el-input v-model="queryParams.titleZh" placeholder="请输入中文名称" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="英文名称" prop="titleEn">
        <el-input v-model="queryParams.titleEn" placeholder="请输入英文名称" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="货币符号" prop="fuhao">
        <el-input v-model="queryParams.fuhao" placeholder="请输入货币符号" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="状态" prop="status">
        <el-select v-model="queryParams.status" placeholder="用户状态" clearable style="width: 240px">
          <el-option v-for="dict in statusDictDatas" :key="parseInt(dict.value)" :label="dict.label" :value="parseInt(dict.value)"/>
        </el-select>
      </el-form-item>
<!--      <el-form-item label="汇率" prop="huilv">-->
<!--        <el-input v-model="queryParams.huilv" placeholder="请输入汇率" clearable @keyup.enter.native="handleQuery"/>-->
<!--      </el-form-item>-->
<!--      <el-form-item label="排序" prop="aorder">-->
<!--        <el-input v-model="queryParams.aorder" placeholder="请输入排序" clearable @keyup.enter.native="handleQuery"/>-->
<!--      </el-form-item>-->
<!--      <el-form-item label="" prop="createAt">-->
<!--        <el-input v-model="queryParams.createAt" placeholder="请输入" clearable @keyup.enter.native="handleQuery"/>-->
<!--      </el-form-item>-->
<!--      <el-form-item label="" prop="updateAt">-->
<!--        <el-input v-model="queryParams.updateAt" placeholder="请输入" clearable @keyup.enter.native="handleQuery"/>-->
<!--      </el-form-item>-->
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
                   v-hasPermi="['ecw:currency:create']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport" :loading="exportLoading"
                   v-hasPermi="['ecw:currency:export']">导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>
    100外币兑人民币（CNY）汇率表
    <!-- 列表 -->
    <el-table v-loading="loading" :data="list">
      <el-table-column label="" align="center" prop="id" />
      <el-table-column label="中文名称" align="center" prop="titleZh" />
      <el-table-column label="英文名称" align="center" prop="titleEn" />
      <el-table-column label="货币符号" align="center" prop="fuhao" />
      <el-table-column label="状态" align="center" prop="show" >
      <template slot-scope="scope">
        <el-switch v-model="scope.row.status" :active-value="0" :inactive-value="1" @change="handleStatusChange(scope.row)" />
      </template>
      </el-table-column>
      <el-table-column label="汇率" align="center" prop="huilv" />
      <el-table-column label="排序" align="center" prop="aorder" />
<!--      <el-table-column label="" align="center" prop="createAt" width="180">-->
<!--        <template slot-scope="scope">-->
<!--          <span>{{ parseTime(scope.row.createAt) }}</span>-->
<!--        </template>-->
<!--      </el-table-column>-->
      <el-table-column label="最后更新时间" align="center" prop="updateAt" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.updateAt) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
                     v-hasPermi="['ecw:currency:update']">修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                     v-hasPermi="['ecw:currency:delete']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                @pagination="getList"/>

    <!-- 对话框(添加 / 修改) -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="中文名称" prop="titleZh">
          <el-input v-model="form.titleZh" placeholder="请输入中文名称" />
        </el-form-item>
        <el-form-item label="英文名称" prop="titleEn">
          <el-input v-model="form.titleEn" placeholder="请输入英文名称" />
        </el-form-item>
        <el-form-item label="货币符号" prop="fuhao">
          <el-input v-model="form.fuhao" placeholder="请输入货币符号" />
        </el-form-item>
<!--        <el-form-item label="状态" prop="show">-->
<!--          <el-input v-model="form.show" placeholder="请输入状态" />-->
<!--        </el-form-item>-->
        <el-form-item label="汇率" prop="huilv">
          <el-input v-model="form.huilv" placeholder="请输入汇率" />
        </el-form-item>
        <el-form-item label="排序" prop="aorder">
          <el-input v-model="form.aorder" placeholder="请输入排序" />
        </el-form-item>
<!--        <el-form-item label="" prop="createAt">-->
<!--          <el-input v-model="form.createAt" placeholder="请输入" />-->
<!--        </el-form-item>-->
<!--        <el-form-item label="" prop="updateAt">-->
<!--          <el-input v-model="form.updateAt" placeholder="请输入" />-->
<!--        </el-form-item>-->
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  createCurrency,
  updateCurrency,
  deleteCurrency,
  getCurrency,
  getCurrencyPage,
  exportCurrencyExcel,
  updateCurrencyStatus
} from "@/api/ecw/currency";
import {CommonStatusEnum} from "@/utils/constants";
import {changeUserStatus} from "@/api/system/user";
import {DICT_TYPE, getDictDatas} from "@/utils/dict";
import {updateBankAccount} from "@/api/ecw/bankAccount";

export default {
  name: "Currency",
  components: {
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 列表
      list: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        titleZh: null,
        titleEn: null,
        fuhao: null,
        status: null,
        huilv: null,
        aorder: null,
        createAt: null,
        updateAt: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      },
      statusDictDatas: getDictDatas(DICT_TYPE.COMMON_STATUS),

    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询列表 */
    getList() {
      this.loading = true;
      // 处理查询参数
      let params = {...this.queryParams};
      // 执行查询
      getCurrencyPage(params).then(response => {
        this.list = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    /** 取消按钮 */
    cancel() {
      this.open = false;
      this.reset();
    },
    /** 表单重置 */
    reset() {
      this.form = {
        id: undefined,
        titleZh: undefined,
        titleEn: undefined,
        fuhao: undefined,
        status: undefined,
        huilv: undefined,
        aorder: undefined,
        createAt: undefined,
        updateAt: undefined,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加";
    },
    // 用户状态修改
    handleStatusChange(row) {
      let text = row.status === CommonStatusEnum.ENABLE ? "启用" : "停用";
      this.$modal.confirm('确认要' + text + '"' + row.titleZh + '"吗?').then(function() {
        // return changeUserStatus(row.id, row.status);
        return updateCurrencyStatus(row);

      }).then(() => {
        this.$modal.msgSuccess(text + "成功");
      }).catch(function() {
        row.status = row.status === CommonStatusEnum.ENABLE ? CommonStatusEnum.DISABLE
          : CommonStatusEnum.ENABLE;
      });
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id;
      getCurrency(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (!valid) {
          return;
        }
        // 修改的提交
        if (this.form.id != null) {
          updateCurrency(this.form).then(response => {
            this.$modal.msgSuccess("修改成功");
            this.open = false;
            this.getList();
          });
          return;
        }
        // 添加的提交
        createCurrency(this.form).then(response => {
          this.$modal.msgSuccess("新增成功");
          this.open = false;
          this.getList();
        });
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const id = row.id;
      this.$modal.confirm('是否确认删除编号为"' + id + '"的数据项?').then(function() {
          return deleteCurrency(id);
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      // 处理查询参数
      let params = {...this.queryParams};
      params.pageNo = undefined;
      params.pageSize = undefined;
      // 执行导出
      this.$modal.confirm('是否确认导出所有数据项?').then(() => {
          this.exportLoading = true;
          return exportCurrencyExcel(params);
        }).then(response => {
          this.$download.excel(response, '货币单位管理.xls');
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
